//Real PolyZ! version 0.06 - RegularPolyhedrons Generator for Realsoft
//This release November 20, 2007
//This script is free for private use. Copyright 2007 Zaug.
//Bugs, Ideas, Improvements-visit www.catmtn.com/realgreeblez.php


															
// Includes ----------------------------------------------------------------------------

//	 Gadgets
include("oops/r3button.js");
include("oops/r3checkb.js");
include("oops/r3cycle.js");
include("real/gadget/r3floatg.js");
include("oops/r3packer.js");
include("oops/r3root.js");
include("oops/r3slider.js");
include("oops/r3string.js");
include("oops/r3window.js");

//	 Objects
include("real/objects/r3level.js");
include("real/layer/r3objlay.js");
include("real/layer/r3prilay.js");
include("real/objects/r3prim.js");
include("real/objects/r3sellis.js");
include("real/objects/r3polygon.js");
include("real/objects/r3polymid.js");
include("real/objects/r3polyhedron.js");

// Variable declarations -----------------------------------------------------
var point_count;
var extrude_height;
var radius;
var sector;
var pie;
var poly_class;

// Function definitions ------------------------------------------------------

// Create Polyhedron function --------------------------------------------------------
function calc_points()
{

//Create an array to hold the points
	poly_points = new Array();

//Polygon formulas

	poly_class = poly.GetClassID();
	if (poly_class == 1648)
	{
		for ( point_loop_inner = 0; point_loop_inner < point_count+1; point_loop_inner++ )
		{
			x_point = (radius) * Math.sin(point_loop_inner * Math.PI * (sector /50)/ point_count);
			z_point = 0.0;
			y_point = (radius) * Math.cos(point_loop_inner * Math.PI * (sector /50) / point_count);
			point_vect = new r3Vect(x_point, y_point, z_point);
			poly_points[poly_points.length]=point_vect;
		}
		if (pie == 1 && sector < 100)
		{
			pie_vect = new r3Vect(0, 0, 0);
			poly_points[poly_points.length]=pie_vect;
		}
	}
//polymid
	else if (poly_class == 1658)
	{
		if (sector < 100)
		{
			for ( point_loop_inner = 0; point_loop_inner < point_count+1; point_loop_inner++ )
			{
				x_point = (radius) * Math.sin(point_loop_inner * Math.PI * (sector /50)/ point_count);
				z_point = 0.0;
				y_point = (radius) * Math.cos(point_loop_inner * Math.PI * (sector /50) / point_count);
				point_vect = new r3Vect(x_point, y_point, z_point);
				poly_points[poly_points.length]=point_vect;
			}
		}
		else
		{
			for ( point_loop_inner = 0; point_loop_inner < point_count; point_loop_inner++ )
			{
				x_point = (radius) * Math.sin(point_loop_inner * Math.PI * 2/ point_count);
				z_point = 0.0;
				y_point = (radius) * Math.cos(point_loop_inner * Math.PI * 2 / point_count);
				point_vect = new r3Vect(x_point, y_point, z_point);
				poly_points[poly_points.length]=point_vect;
			}
		}
			if (pie == 1 && sector < 100)
			{
				pie_vect = new r3Vect(0, 0, 0);
				poly_points[poly_points.length]=pie_vect;
			}
			x_point = 0;
			z_point = extrude_height;
			y_point = 0;
			point_vect = new r3Vect(x_point, y_point, z_point);
			poly_points[poly_points.length]=point_vect;
	}
	else if (poly_class == 1654)
	{
		if (sector < 100)
		{
			for ( point_loop_inner = 0; point_loop_inner < point_count+1; point_loop_inner++ )
			{
				x_point = (radius) * Math.sin(point_loop_inner * Math.PI * (sector /50)/ point_count);
				z_point = 0.0;
				y_point = (radius) * Math.cos(point_loop_inner * Math.PI * (sector /50) / point_count);
				point_vect = new r3Vect(x_point, y_point, z_point);
				poly_points[poly_points.length]=point_vect;
			}
		}
		//x_point = (radius) * Math.sin(0 * Math.PI * (sector /50) / point_count);
		//x_point = 0.0;
		//z_point = extrude_height;
		//y_point = 0.0;
		//y_point = (radius) * Math.cos(0 * Math.PI * (sector /50) / point_count);
		//point_vect = new r3Vect(x_point, y_point, z_point);
		else
		{
			for ( point_loop_inner = 0; point_loop_inner < point_count; point_loop_inner++ )
			{
				x_point = (radius) * Math.sin(point_loop_inner * Math.PI * 2/ point_count);
				z_point = 0.0;
				y_point = (radius) * Math.cos(point_loop_inner * Math.PI * 2 / point_count);
				point_vect = new r3Vect(x_point, y_point, z_point);
				poly_points[poly_points.length]=point_vect;
			}
		}
		if (pie == 1 && sector < 100)
		{
			pie_vect = new r3Vect(0, 0, 0);
			poly_points[poly_points.length]=pie_vect;
		}
		x_point = (radius) * Math.sin(0 * Math.PI * 2 / point_count);
		z_point = extrude_height;
		y_point = (radius) * Math.cos(0 * Math.PI * 2 / point_count);
		point_vect = new r3Vect(x_point, y_point, z_point);
		poly_points[poly_points.length]=point_vect;
	}
	else
	{
	}
}

function Create_polygon()
{
	var primLayer = new r3Primlayer();
	primLayer.r3Attach(Get("CurrentProject.Geometrics"));
	primLayer.LOCKEXCLUSIVE();
// Create a new analytical Polygon
	poly = new r3Polygon(0);
	calc_points(0);
// Set the Polyhedron up
	vectPos=new r3Vect(0,0,0);
	poly.SetMatrixTranslate(vectPos);
	poly.SetCount(poly_points.length);
	var p = new r3Vect();
	var p0 = new r3Vect();
	for (point_loop = 0; point_loop < poly_points.length; point_loop++)
	{
		p0 = poly_points[point_loop];
		p.set(p0.x,p0.y,p0.z);
		poly.SETPOINTLOCAL(point_loop, p);
	}

// Insert it into parent
	primLayer.INSERT(0, 0, poly);
	// Tidy up
	delete vectPos;
	primLayer.RELEASE();
}
function Create_polymid()
{
	var primLayer = new r3Primlayer();
	primLayer.r3Attach(Get("CurrentProject.Geometrics"));
	primLayer.LOCKEXCLUSIVE();
// Create a new analytical Polymid
	poly = new r3Polymid(0);
	calc_points(0);
// Set the Polymid up
	vectPos=new r3Vect(0,0,0);
	poly.SetMatrixTranslate(vectPos);
	poly.SetCount(poly_points.length-1);
	var p = new r3Vect();
	for (point_loop = 0; point_loop < poly_points.length; point_loop++)
	{
		p0 = poly_points[point_loop];
		p.set(p0.x,p0.y,p0.z);
		poly.SETPOINTLOCAL(point_loop, p);
	}
// Insert it into parent
	primLayer.INSERT(0, 0, poly);
	// Tidy up
	delete vectPos;
	primLayer.RELEASE();
}
function Create_polyhedron()
{
	var primLayer = new r3Primlayer();
	primLayer.r3Attach(Get("CurrentProject.Geometrics"));
	primLayer.LOCKEXCLUSIVE();
// Create a new analytical Polyhedron
	poly = new r3Polyhedron(0);
	calc_points();
// Set the Polyhedron up
	vectPos=new r3Vect(0,0,0);
	poly.SetMatrixTranslate(vectPos);
	poly.SetCount(poly_points.length-1);
	var p = new r3Vect();
	for (point_loop = 0; point_loop < poly_points.length; point_loop++)
	{
		p0 = poly_points[point_loop];
		p.set(p0.x,p0.y,p0.z);
		poly.SETPOINTLOCAL(point_loop, p);
	}

// Insert it into parent
	primLayer.INSERT(0, 0, poly);
	// Tidy up
	delete vectPos;
	primLayer.RELEASE();
}

//Interface functions--------------------------------------------------

//Get sides slider value
function slide_sides( object, event, value )
{
	point_count = value;
}

//Get radius slider value
function slide_radius (object, event, value)
{
	radius = value;
}

//Get extrusion slider value
function slide_extrude (object, event, value)
{
	extrude_height = value;
}


//Get sector slider value
function slide_sector (object, event, value)
{
	if (value < 100)
	{
		pie_checkb_packer.SetStealth(FALSE);
	}
	else
	{
		pie_checkb_packer.SetStealth(TRUE);
	}
	sector = value;
	window.FIT(R3WFP_BESTFIT);
}

//Pie Checkbox Hook
function HookSetPie (object, event,checked)
{
	if(event == R3OGM_GADGETUP)
	{
        	if(checked)
		{
			pie =1;
			
		}
		else
		{
			pie = 0;
		}
	window.FIT(R3WFP_BESTFIT);
	}
	return 1;

}
//create Polygon button pressed
function create_polygon_button(object, event, value)
{
   	 if(event == R3OGM_GADGETUP) 
        {
		Create_polygon();
	}
}

//create Polymid button pressed
function create_polymid_button(object, event, value)
{
   	 if(event == R3OGM_GADGETUP) 
        {
		Create_polymid();
	}
}

//create Polyhedron button pressed
function create_polyhedron_button(object, event, value)
{
   	 if(event == R3OGM_GADGETUP) 
        {
		Create_polyhedron();
	}
}

//Main program--------------------------------------------------------------------------
{

	point_count = 5;
	extrude_height = 0.01;
	radius = 0.01;
	sector = 100;
	pie = 0;

	window = new r3Window(R3WGA_Parent, _r3gui,
			R3WGA_Left, 100,
			R3WGA_Top, 250,
			R3WA_Flags,   R3WASF_DRAGBAR + R3WASF_CLOSE + R3WASF_MAXIMIZE + R3WASF_MINIMIZE,
			R3WA_Title, "Real PolyZ! 0.06",
			R3WA_ReportCloseWindow, TRUE,
			R3WA_ReportNewSize, TRUE);
	
	main_packer = new r3Packer(R3PA_Orientation, R3PAOF_VERTICAL);
			window.SetGmanager(main_packer);
	
	polygon_button = new r3Button(
			R3WGA_Parent, window,
			R3GA_Text, "Create Polygon   ",
			R3RA_Hook, create_polygon_button,
			R3GA_ToolTip, "Create a polygon with X sides; extrusion depth is ignored");
	main_packer.ADD(R3PAPF_FILLX, 0, polygon_button);
	
	polymid_button = new r3Button(
			R3WGA_Parent, window,
			R3GA_Text, "Create Polymid   ",
			R3RA_Hook, create_polymid_button,
			R3GA_ToolTip, "Create a polyhedron with X sides, at the specified radius and extrusion depth");
	main_packer.ADD(R3PAPF_FILLX, 0, polymid_button);
	
	polyhedron_button = new r3Button(
			R3WGA_Parent, window,
			R3GA_Text, "Create Polyhedron   ",
			R3RA_Hook, create_polyhedron_button,
			R3GA_ToolTip, "Create a polyhedron with X sides, at the specified radius and extrusion depth");
	main_packer.ADD(R3PAPF_FILLX, 0, polyhedron_button);
	
//Number of sides slider
	sides_slider = new r3Slider(
			R3WGA_Parent, window,
			R3GA_Text," Sides",
			R3RA_Hook, slide_sides,
			R3GSLA_Min, 3,
			R3GSLA_Max, 100,
			R3GSLA_Level,5,
			R3GA_ToolTip, "Determines the number of sides for the polyhedron; in the case of a sector,  it is the count for the 'curved' sides.");
		if(sides_slider)
			main_packer.ADD(R3PAPF_EXPAND | R3PAPF_FILLX, R3PAAF_ALIGN, sides_slider);

//Radius Slider
	radius_float = new r3Floatgadget(
			R3WGA_Parent, window,
			R3GA_Text, "Radius",
			R3RA_Hook, slide_radius,
			R3GA_ToolTip, "Radius at outer points of the poly."
		);
		radius_float.SetFloat(radius);
		radius_float.SetMin(0.001);
		radius_float.SetNumDecimals(3);
	
		if(radius_float)
			main_packer.ADD(R3PAPF_EXPAND | R3PAPF_FILLX | R3PAPF_FILLY, R3PAAF_ALIGN, radius_float);
//
//Extrusion Height Slider
	extrude_float = new r3Floatgadget(
			R3WGA_Parent, window,
			R3GA_Text, "Extrude Depth",
			R3RA_Hook, slide_extrude,
			R3GA_ToolTip, "Extrusion distance in the Z direction."
		);
		extrude_float.SetFloat(extrude_height);
		extrude_float.SetMin(0.001);
		extrude_float.SetNumDecimals(3);
	
		if(extrude_float)
			main_packer.ADD(R3PAPF_EXPAND | R3PAPF_FILLX | R3PAPF_FILLY, R3PAAF_ALIGN, extrude_float);

	sector_slider = new r3Slider(
			R3WGA_Parent, window,
			R3GA_Text," Sector %",
			R3RA_Hook, slide_sector,
			R3GSLA_Min, 1,
			R3GSLA_Max, 100,
			R3GSLA_Level, 100,
			R3GA_ToolTip, "Determines the percentage of the circlular construct to distribute the sides over.");
		if(sector_slider)
			main_packer.ADD(R3PAPF_EXPAND | R3PAPF_FILLX, R3PAAF_ALIGN, sector_slider);

	pie_checkb_packer = new r3Packer(R3PA_Orientation, R3PAOF_HORIZONTAL);
	main_packer.ADD(R3PAPF_EXPAND | R3PAPF_FILLX, 0, pie_checkb_packer);
	// pie checkbox
	pie_checkb = new r3Checkbox(
		R3RA_Hook, HookSetPie,
		R3WGA_Parent, window,
		R3GA_Text, "Pie-Cut Sector",
		R3GCBA_Checked, pie,
		R3GA_ToolTip, "Makes a 'pie' cutout of the sector.");
		if(pie_checkb)
			pie_checkb_packer.ADD(R3PAPF_EXPAND | R3PAPF_FILLX | R3PAPF_FILLY, 0, pie_checkb);

	//draw window	
	pie_checkb_packer.SetStealth(TRUE);
	window.FIT(R3WFP_BESTFIT);
	window.REALIZE();
}